AchSnd.MsgFrame = CreateFrame("Frame" , "AchSndMessageFrame", UIParent )
local me = AchSnd.MsgFrame
me:SetFrameStrata("DIALOG")
me:Hide()

local MOBuff = 5 -- Mouse Over Pixel Buffer
local e = 0 -- elapsed time counter
local cdown = 0 -- auto cancel countdown
local fdelay = 0 -- Fade Countdown

local update= 1/10
local Backdrop1={
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 32,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0
	}
}
local Backdrop2={
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 32,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0
	}
}	
me:EnableMouse(true)
me:SetPoint("CENTER", UIParent, "CENTER")
me:SetHeight( 125 )
me:SetWidth( 400 )
me:SetBackdrop( Backdrop1 )
me:SetBackdropColor( 128, 128,128, 1)
me:SetBackdropBorderColor( 255, 255, 255, 1)
me:SetMovable(true)
me:SetUserPlaced(true)
me:SetClampedToScreen(true)
	
me:SetScript("OnShow", function(self)
	--Set Frame Positon for future alerts
	if ((AchSnd_SettingsPC.AlertPosSet == 0) and (AchSnd_Settings.NewMsgBox == "on"))then
		me.Text:SetText( "Please move the \"Grats Alert Frame\" to where you would like it and close it to save its position (You can always move it again later by dragging the title box around)" )
		me.GratsButton:SetText("Click Me!")
		me.CancelButton:SetText("No, Click Me!")
		return
	end
	
	if (AchSnd_Settings.AutoFade == "off") then
		me:SetAlpha(1)
	end
	
	local mode = AchSnd.MBox.Mode
	if ( #mode.say > 0 and #mode.guild == 0 and #mode.party == 0 ) then
		me.GratsButton:SetText("Say Grats")
	elseif ( #mode.say == 0 and #mode.guild > 0 and #mode.party == 0 ) then
		me.GratsButton:SetText("Guild Grats")
	elseif ( #mode.say == 0 and #mode.guild == 0 and #mode.party > 0 ) then
		me.GratsButton:SetText("Party Grats")
	else
		me.GratsButton:SetText("Mixed Grats")
	end
	
	me.Text:SetText( AchSnd.MBox.text )
	me.CancelButton:SetText("Cancel")
	
	if (AchSnd.MBox.Test) then
		cdown = AchSnd.panel.Timeout:GetValue()
		fdelay = AchSnd.panel.FadeDelay:GetValue()
	else
		cdown = AchSnd_Settings.Timeout
		fdelay = AchSnd_Settings.FadeDelay
	end
	
	if (AchSnd_Settings.Multi == "on") then
		me.PCBkgnd:Show()
		me.GCBkgnd:Show()
		me.SCBkgnd:Show()
		me.PCText:SetText(string.format("%i PARTY", #AchSnd.MBox.Mode.party))
		me.GCText:SetText(string.format("%i GUILD", #AchSnd.MBox.Mode.guild))
		me.SCText:SetText(string.format("%i SAY", #AchSnd.MBox.Mode.say))
	else
		me.PCBkgnd:Hide()
		me.GCBkgnd:Hide()
		me.SCBkgnd:Hide()
	end
	
end)

me:SetScript("OnUpdate", function(self, elapsed)
	if (AchSnd_SettingsPC.AlertPosSet == 0) then
		return
	end

	e = e + elapsed
	if (e < update) then
		return
	end

	-- Items to be updated goes here
	local multi = AchSnd_Settings.Multi == "on" 
	local guild = #AchSnd.MBox.Mode.guild > 0
	local party = #AchSnd.MBox.Mode.party > 0
	local say = #AchSnd.MBox.Mode.say > 0
	local AutoFadeChecked = AchSnd.panel.AutoFade:GetChecked()
	local MultiChecked = AchSnd.panel.Multi:GetChecked()
	local test = AchSnd.MBox.Test
	local MsgBoxTimeout = AchSnd.panel.Timeout:GetValue()
	local count = #AchSnd.MBox.Mode.guild + #AchSnd.MBox.Mode.party + #AchSnd.MBox.Mode.say
	
	if (AchSnd_Settings.NewMsgBox == "off" and not( test )) then
		me:Hide()
	end
	
	if ( multi and not( test) ) or ( test and MultiChecked )then
		me.PCBkgnd:Show()
		me.GCBkgnd:Show()
		me.SCBkgnd:Show()
		me.PCText:SetText(string.format("%i PARTY", #AchSnd.MBox.Mode.party))
		me.GCText:SetText(string.format("%i GUILD", #AchSnd.MBox.Mode.guild))
		me.SCText:SetText(string.format("%i SAY", #AchSnd.MBox.Mode.say))
	else
		me.PCBkgnd:Hide()
		me.GCBkgnd:Hide()
		me.SCBkgnd:Hide()
	end

	if ( count > 1 ) and ( multi ) then -- More than one person to grat
		me:SetBackdrop( Backdrop2 )
		me.TitleBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
		me.PCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
		me.GCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
		me.SCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Header")
		
		if ( say and not( guild ) and not( party )) then
			me.GratsButton:SetText( string.format("%i Say Grats", count))
		elseif ( not( say ) and guild and not( party )) then
			me.GratsButton:SetText(string.format("%i Guild Grats", count))
		elseif ( not( say ) and not( guild ) and party ) then
			me.GratsButton:SetText(string.format("%i Party Grats", count))
		else
			me.GratsButton:SetText(string.format("%i Mixed Grats", count))
		end
	
	else -- Only 1 person to grat
	
		me:SetBackdrop( Backdrop1 ) 
		me.TitleBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
		me.PCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
		me.GCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
		me.SCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	end
	
	if ( test and AutoFadeChecked ) or ( not(test) and AchSnd_Settings.AutoFade == "on") then
		fdelay = (fdelay - e)
		if (fdelay <= 0 ) then 
			if ((me:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff)) or (me.TitleRegion:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff))) then
				me:SetAlpha( 1 )
			else
				me:SetAlpha( test and AchSnd.panel.MinAlpha:GetValue() or AchSnd_Settings.MinAlpha )
			end
			fdelay = 0
		else
			me:SetAlpha( 1)
		end
	else
		me:SetAlpha( 1)
	end

	if (test and MsgBoxTimeout ~= 0) or ( not(test) and AchSnd.MsgBoxTimeout ~= 0) then
		cdown = (cdown - e)
		if (cdown > 0) then
			me.CancelButton:SetText( string.format("Cancel ( %i )", math.ceil(cdown)))
		elseif (cdown <= 0) then
			
	-- Countdown timeout
			me:Hide()
			if ( test ) then
				InterfaceOptionsFrame:Show()
				AchSnd.MBox.Test = false
			end
			AchSnd.MBox.last = ""
			wipe(AchSnd.MBox.Mode.guild)
			wipe(AchSnd.MBox.Mode.party)
			wipe(AchSnd.MBox.Mode.say)
		end
	end
	
	e=0
end)

-- Title region
me.TitleRegion = me:CreateTitleRegion()
me.TitleRegion:SetSize( 324, 64)
me.TitleRegion:SetPoint( "TOP", me, "TOP", 0,12)

-- Title frame header
me.TitleBkgnd=me:CreateTexture(nil , "ARTWORK")
me.TitleBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
me.TitleBkgnd:SetSize( 324, 64)
me.TitleBkgnd:SetPoint( "TOP", me, "TOP", 0,12)

-- Title frame text
me.Title = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
me.Title:SetText("Achievement Sounds")
me.Title:SetPoint( "CENTER", me.TitleBkgnd, "CENTER", 0, 12 )
me.Title:SetJustifyH( "CENTER" )
me.Title:SetJustifyV( "MIDDLE" )

-- Box Text
me.Text = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
me.Text:SetPoint( "TOP", me.TitleBkgnd, "TOP", 0, -16 )
me.Text:SetSize( 376, 100)
me.Text:SetJustifyH( "CENTER" )
me.Text:SetJustifyV( "MIDDLE" )

-- Grat Button
me.GratsButton = CreateFrame( "Button", "AchSndMsgBoxGratButton", me, "UIPanelButtonTemplate" )
me.GratsButton:SetPoint("CENTER", me, "BOTTOM", -85, 25)
me.GratsButton:SetSize( 150, 25)
me.GratsButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	-- Testing the frame
	if (AchSnd.MBox.Test) then
		InterfaceOptionsFrame:Show()
		AchSnd.MBox.Test = false
		return
	end
	
	-- Set Alert Box Position
	if (AchSnd_SettingsPC.AlertPosSet == 0) then
		AchSnd_SettingsPC.AlertPosSet = 1
		return
	end
	
	-- grats stuff goes here
	local mode = AchSnd.MBox.mode
	if (AchSnd_Settings.Random == "on") then
		AchSnd.RandMsg()
	else
		AchSnd.DefMsg()
	end
	AchSnd.MBox.last = ""
end)

-- Cancel Button
me.CancelButton = CreateFrame( "Button", "AchSndMsgBoxCancelButton", me, "UIPanelButtonTemplate" )
me.CancelButton:SetPoint("CENTER", me, "BOTTOM", 85, 25)
me.CancelButton:SetSize( 150, 25)
me.CancelButton:SetText("Cancel")
me.CancelButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	
	-- Testing the frame
	if (AchSnd.MBox.Test) then
		InterfaceOptionsFrame:Show()
		AchSnd.MBox.Test = false
		return
	end

	-- Set Alert Box position
	if (AchSnd_SettingsPC.AlertPosSet == 0) then
		AchSnd_SettingsPC.AlertPosSet = 1
		return
	end
	-- cancel stuff goes here
	wipe(AchSnd.MBox.Mode.guild)
	wipe(AchSnd.MBox.Mode.party)
	wipe(AchSnd.MBox.Mode.say)
	AchSnd.MBox.last = ""
end)


local xmove = 58
local ymove = 14
local width = 250
-- Party count bkgnd
	me.PCBkgnd=me:CreateTexture(nil , "ARTWORK")
	me.PCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	me.PCBkgnd:SetSize( width, 64)
	me.PCBkgnd:SetPoint( "TOPLEFT", me, "BOTTOMLEFT", -xmove, ymove)

-- Party count
	me.PCText = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
	me.PCText:SetText(string.format("%i PARTY", #AchSnd.MBox.Mode.party))
	me.PCText:SetPoint( "CENTER", me.PCBkgnd, "CENTER",0, 12 )
	me.PCText:SetJustifyH( "CENTER" )
	me.PCText:SetJustifyV( "MIDDLE" )

-- Guild count bkgnd
	me.GCBkgnd=me:CreateTexture(nil , "ARTWORK")
	me.GCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	me.GCBkgnd:SetSize( width, 64)
	me.GCBkgnd:SetPoint( "TOP", me, "BOTTOM", 0, ymove)

-- Guild count
	me.GCText = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
	me.GCText:SetText(string.format("%i GUILD", #AchSnd.MBox.Mode.guild))
	me.GCText:SetPoint( "CENTER", me.GCBkgnd, "CENTER", 0, 12 )
	me.GCText:SetJustifyH( "CENTER" )
	me.GCText:SetJustifyV( "MIDDLE" )

-- Say count bkgnd
	me.SCBkgnd=me:CreateTexture(nil , "ARTWORK")
	me.SCBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	me.SCBkgnd:SetSize( width, 64)
	me.SCBkgnd:SetPoint( "TOPRIGHT", me, "BOTTOMRIGHT", xmove, ymove)

-- Say count
	me.SCText = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
	me.SCText:SetText(string.format("%i SAY", #AchSnd.MBox.Mode.say))
	me.SCText:SetPoint( "CENTER", me.SCBkgnd, "CENTER", 0, 12 )
	me.SCText:SetJustifyH( "CENTER" )
	me.SCText:SetJustifyV( "MIDDLE" )